<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>HexPlot: /home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/utils/cpp_utils.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.1 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>/home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/utils/cpp_utils.h</h1><a href="cpp__utils_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00007"></a>00007 <span class="preprocessor">#ifndef CPP_UTILS_H</span>
<a name="l00008"></a>00008 <span class="preprocessor"></span><span class="preprocessor">#define CPP_UTILS_H</span>
<a name="l00009"></a>00009 <span class="preprocessor"></span>
<a name="l00010"></a>00010 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00011"></a>00011 <span class="preprocessor">#include &lt;cctype&gt;</span>
<a name="l00012"></a>00012 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00013"></a>00013 <span class="preprocessor">#include &lt;cstdarg&gt;</span>
<a name="l00014"></a>00014 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00015"></a>00015 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00016"></a>00016 <span class="preprocessor">#include &lt;functional&gt;</span>
<a name="l00017"></a>00017 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00020"></a>00020 <span class="preprocessor">#include &lt;regex&gt;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef _WIN32</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span><span class="keyword">const</span> <span class="keywordtype">bool</span> IS_WINDOWS_COMPILATION = <span class="keyword">true</span>;
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;stdint.h&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;windows.h&gt;</span>
<a name="l00029"></a>00029 <span class="keyword">const</span> <span class="keywordtype">int</span> MAX_INTEGER = INT_MAX;
<a name="l00030"></a>00030 <span class="keyword">const</span> <span class="keywordtype">double</span> MAX_DOUBLE = DBL_MAX;
<a name="l00031"></a>00031 <span class="preprocessor">#else</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &lt;unistd.h&gt;</span>
<a name="l00033"></a>00033 <span class="keyword">const</span> <span class="keywordtype">bool</span> IS_WINDOWS_COMPILATION = <span class="keyword">false</span>;
<a name="l00034"></a>00034 <span class="keyword">const</span> <span class="keywordtype">int</span> MAX_INTEGER = std::numeric_limits&lt;int&gt;::max();
<a name="l00035"></a>00035 <span class="keyword">const</span> <span class="keywordtype">double</span> MAX_DOUBLE = std::numeric_limits&lt;double&gt;::max();
<a name="l00036"></a>00036 <span class="preprocessor">#endif</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="keyword">const</span> uint64_t MAX_HASH_SIZE = uint64_t(exp2(32));  <span class="comment">// well below max uint64_t</span>
<a name="l00039"></a>00039 <span class="keyword">const</span> uint64_t HASH_PRIME = uint64_t(exp2(16) + 1);
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#define ANSI_COLOR_RESET &quot;\x1b[0m&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BLACK &quot;\x1b[30m&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_RED &quot;\x1b[31m&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_GREEN &quot;\x1b[32m&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_YELLOW &quot;\x1b[33m&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BLUE &quot;\x1b[34m&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_MAGENTA &quot;\x1b[35m&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_CYAN &quot;\x1b[36m&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_WHITE &quot;\x1b[37m&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDBLACK &quot;\033[1m\033[30m&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDRED &quot;\033[1m\033[31m&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDGREEN &quot;\033[1m\033[32m&quot;</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDYELLOW &quot;\033[1m\033[33m&quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDBLUE &quot;\033[1m\033[34m&quot;</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDMAGENTA &quot;\033[1m\033[35m&quot;</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDCYAN &quot;\033[1m\033[36m&quot;</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#define ANSI_COLOR_BOLDWHITE &quot;\033[1m\033[37m&quot;</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>
<a name="l00059"></a>00059 <span class="preprocessor">#define LOCATION (get_file_name(__FILE__, 1) + &quot;: &quot; + int_to_string(__LINE__) + &quot; in &quot; + __FUNCTION__).c_str()</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#define DEBUG_MSG(x, ...)                                                                                              \</span>
<a name="l00061"></a>00061 <span class="preprocessor">  {                                                                                                                    \</span>
<a name="l00062"></a>00062 <span class="preprocessor">    if (verbose &gt; 1) {                                                                                                 \</span>
<a name="l00063"></a>00063 <span class="preprocessor">      switch_color(&quot;MAGENTA&quot;);                                                                                         \</span>
<a name="l00064"></a>00064 <span class="preprocessor">      fprintf(stderr, &quot;[DEBUG]&quot;);                                                                                      \</span>
<a name="l00065"></a>00065 <span class="preprocessor">      fprintf(stderr, &quot; (%s)&quot;, LOCATION);                                                                              \</span>
<a name="l00066"></a>00066 <span class="preprocessor">      switch_color(&quot;RESET&quot;);                                                                                           \</span>
<a name="l00067"></a>00067 <span class="preprocessor">      fprintf(stderr, &quot; &quot; x &quot;\n&quot;, ##__VA_ARGS__);                                                                      \</span>
<a name="l00068"></a>00068 <span class="preprocessor">    }                                                                                                                  \</span>
<a name="l00069"></a>00069 <span class="preprocessor">  }</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#define INFO_MSG(x, ...)                                                                                               \</span>
<a name="l00071"></a>00071 <span class="preprocessor">  {                                                                                                                    \</span>
<a name="l00072"></a>00072 <span class="preprocessor">    if (verbose &gt; 0) {                                                                                                 \</span>
<a name="l00073"></a>00073 <span class="preprocessor">      switch_color(&quot;BLUE&quot;);                                                                                            \</span>
<a name="l00074"></a>00074 <span class="preprocessor">      fprintf(stderr, &quot;[INFO]&quot;);                                                                                       \</span>
<a name="l00075"></a>00075 <span class="preprocessor">      fprintf(stderr, &quot; (%s)&quot;, LOCATION);                                                                              \</span>
<a name="l00076"></a>00076 <span class="preprocessor">      switch_color(&quot;RESET&quot;);                                                                                           \</span>
<a name="l00077"></a>00077 <span class="preprocessor">      fprintf(stderr, &quot; &quot; x &quot;\n&quot;, ##__VA_ARGS__);                                                                      \</span>
<a name="l00078"></a>00078 <span class="preprocessor">    }                                                                                                                  \</span>
<a name="l00079"></a>00079 <span class="preprocessor">  }</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="preprocessor">#define STANDARD_MSG(x, ...)                                                                                           \</span>
<a name="l00081"></a>00081 <span class="preprocessor">  {                                                                                                                    \</span>
<a name="l00082"></a>00082 <span class="preprocessor">    fprintf(stderr, &quot;[MESSAGE]&quot;);                                                                                      \</span>
<a name="l00083"></a>00083 <span class="preprocessor">    fprintf(stderr, &quot; &quot; x &quot;\n&quot;, ##__VA_ARGS__);                                                                        \</span>
<a name="l00084"></a>00084 <span class="preprocessor">  }</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span><span class="preprocessor">#define WARNING_MSG(x, ...)                                                                                            \</span>
<a name="l00086"></a>00086 <span class="preprocessor">  {                                                                                                                    \</span>
<a name="l00087"></a>00087 <span class="preprocessor">    switch_color(&quot;YELLOW&quot;);                                                                                            \</span>
<a name="l00088"></a>00088 <span class="preprocessor">    fprintf(stderr, &quot;[WARNING]&quot;);                                                                                      \</span>
<a name="l00089"></a>00089 <span class="preprocessor">    fprintf(stderr, &quot; (%s)&quot;, LOCATION);                                                                                \</span>
<a name="l00090"></a>00090 <span class="preprocessor">    switch_color(&quot;RESET&quot;);                                                                                             \</span>
<a name="l00091"></a>00091 <span class="preprocessor">    fprintf(stderr, &quot; &quot; x &quot;\n&quot;, ##__VA_ARGS__);                                                                        \</span>
<a name="l00092"></a>00092 <span class="preprocessor">  }</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span><span class="preprocessor">#define ERROR_MSG(x, ...)                                                                                              \</span>
<a name="l00094"></a>00094 <span class="preprocessor">  {                                                                                                                    \</span>
<a name="l00095"></a>00095 <span class="preprocessor">    switch_color(&quot;RED&quot;);                                                                                               \</span>
<a name="l00096"></a>00096 <span class="preprocessor">    fprintf(stderr, &quot;[ERROR]&quot;);                                                                                        \</span>
<a name="l00097"></a>00097 <span class="preprocessor">    fprintf(stderr, &quot; (%s)&quot;, LOCATION);                                                                                \</span>
<a name="l00098"></a>00098 <span class="preprocessor">    switch_color(&quot;RESET&quot;);                                                                                             \</span>
<a name="l00099"></a>00099 <span class="preprocessor">    fprintf(stderr, &quot; &quot; x &quot;\n&quot;, ##__VA_ARGS__);                                                                        \</span>
<a name="l00100"></a>00100 <span class="preprocessor">  }</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00103"></a>00103 <span class="keywordtype">void</span> print_progress_bar(<span class="keywordtype">int</span> now, <span class="keywordtype">int</span> max);
<a name="l00105"></a>00105 <span class="keywordtype">void</span> string_to_array(<span class="keyword">const</span> std::string&amp; str, <span class="keywordtype">int</span> arr[]);
<a name="l00107"></a>00107 <span class="keywordtype">void</span> string_to_array_double(<span class="keyword">const</span> std::string&amp; str, <span class="keywordtype">double</span> arr[]);
<a name="l00109"></a>00109 <span class="keywordtype">void</span> replace_val_two_col_file(<span class="keyword">const</span> std::string&amp; fileName, <span class="keyword">const</span> std::string&amp; searchKey, <span class="keyword">const</span> std::string&amp; newVal);
<a name="l00111"></a>00111 <span class="keywordtype">void</span> switch_color(<span class="keyword">const</span> std::string&amp; color);
<a name="l00113"></a>00113 <span class="keywordtype">void</span> print_colors();
<a name="l00115"></a>00115 <span class="keywordtype">void</span> printf_file(<span class="keyword">const</span> std::string&amp; text, std::ofstream&amp; fileout);
<a name="l00117"></a>00117 <span class="keywordtype">bool</span> starts_with(<span class="keyword">const</span> std::string&amp; a, <span class="keyword">const</span> std::string&amp; b);
<a name="l00119"></a>00119 <span class="keywordtype">bool</span> ends_with(std::string a, std::string b);
<a name="l00121"></a>00121 <span class="keywordtype">bool</span> contains(<span class="keyword">const</span> std::string&amp; a, <span class="keyword">const</span> std::string&amp; b);
<a name="l00123"></a>00123 <span class="keywordtype">bool</span> match(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; r);
<a name="l00125"></a>00125 <span class="keywordtype">bool</span> file_is_empty(<span class="keyword">const</span> std::string&amp; fileName);
<a name="l00127"></a>00127 <span class="keywordtype">bool</span> is_file(<span class="keyword">const</span> std::string&amp; fileName);
<a name="l00129"></a>00129 <span class="keywordtype">bool</span> is_file(<span class="keywordtype">char</span>* fileName);
<a name="l00131"></a>00131 <span class="keywordtype">bool</span> compare_strings(<span class="keyword">const</span> std::string&amp; a, <span class="keyword">const</span> std::string&amp; b);
<a name="l00133"></a>00133 <span class="keywordtype">bool</span> is_in_array(<span class="keywordtype">int</span> element, <span class="keywordtype">int</span> arr[], <span class="keywordtype">int</span> arraySize);
<a name="l00135"></a>00135 <span class="keywordtype">bool</span> is_same_elements(<span class="keyword">const</span> <span class="keywordtype">int</span> arr[2], <span class="keywordtype">int</span> badOne, <span class="keywordtype">int</span> badTwo);
<a name="l00137"></a>00137 <span class="keywordtype">bool</span> is_in_vector(<span class="keywordtype">int</span> num, std::vector&lt;int&gt; vec);
<a name="l00139"></a>00139 <span class="keywordtype">bool</span> is_in_vector(<span class="keywordtype">double</span>, std::vector&lt;double&gt;);
<a name="l00141"></a>00141 <span class="keywordtype">bool</span> yes_no_request(<span class="keyword">const</span> std::string&amp; prompt = <span class="stringliteral">&quot;Do you want to continue?&quot;</span>);
<a name="l00143"></a>00143 <span class="keywordtype">double</span> get_mean(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; v);
<a name="l00145"></a>00145 <span class="keywordtype">double</span> get_mean_err(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; v);
<a name="l00147"></a>00147 <span class="keywordtype">double</span> get_median(std::vector&lt;double&gt;&amp; v);
<a name="l00149"></a>00149 <span class="keywordtype">double</span> get_median_err(std::vector&lt;double&gt;&amp; v);
<a name="l00150"></a>00150 
<a name="l00152"></a>00152 <span class="keywordtype">int</span> get_n_digits_in_string(std::string str);
<a name="l00154"></a>00154 <span class="keywordtype">int</span> digits_from_string(std::string str, <span class="keywordtype">int</span> nth = 0);
<a name="l00156"></a>00156 <span class="keywordtype">int</span> sign(<span class="keywordtype">double</span> v);
<a name="l00158"></a>00158 <span class="keywordtype">int</span> get_n_columns(<span class="keyword">const</span> std::string&amp; fileName, <span class="keyword">const</span> std::string&amp; delim = <span class="stringliteral">&quot;\t&quot;</span>);
<a name="l00160"></a>00160 <span class="keywordtype">int</span> get_n_instance(<span class="keyword">const</span> std::string&amp; a, <span class="keyword">const</span> std::string&amp; b, <span class="keywordtype">bool</span> omitRepetitions = <span class="keyword">false</span>);
<a name="l00162"></a>00162 <span class="keywordtype">int</span> positive_modulo(<span class="keywordtype">int</span> i, <span class="keywordtype">int</span> n);
<a name="l00164"></a>00164 <span class="keywordtype">int</span> get_argc(<span class="keyword">const</span> std::string&amp; cmd);
<a name="l00165"></a>00165 
<a name="l00167"></a>00167 uint64_t big_mod(uint64_t a, uint64_t b, uint64_t c);
<a name="l00169"></a>00169 uint64_t modulo_hash(uint64_t i);
<a name="l00171"></a>00171 uint64_t modulo_merge_hash(uint64_t i, uint64_t j);
<a name="l00173"></a>00173 uint64_t modulo_hash_double(<span class="keywordtype">double</span> d);
<a name="l00174"></a>00174 
<a name="l00176"></a>00176 std::string get_current_dir();
<a name="l00178"></a>00178 std::string int_to_string(<span class="keywordtype">int</span> number, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> digits = 0);
<a name="l00180"></a>00180 std::string float_to_string(<span class="keywordtype">float</span> number, <span class="keywordtype">int</span> nDigitsAfterPoint = 1);
<a name="l00182"></a>00182 std::string double_to_string(<span class="keywordtype">double</span> number, <span class="keywordtype">int</span> nDigitsAfterPoint = 1);
<a name="l00184"></a>00184 std::string print_value(<span class="keyword">const</span> std::string&amp; valueName, <span class="keywordtype">double</span> value, <span class="keywordtype">double</span> unc, std::string unitName = <span class="stringliteral">&quot;&quot;</span>,
<a name="l00185"></a>00185                         <span class="keywordtype">int</span> nSigDigits = -1);
<a name="l00187"></a>00187 std::string&amp; ltrim(std::string&amp; s);
<a name="l00189"></a>00189 std::string&amp; rtrim(std::string&amp; s);
<a name="l00191"></a>00191 std::string&amp; trim(std::string&amp; s);
<a name="l00193"></a>00193 std::string get_file_name(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> <span class="keywordtype">int</span> nLayers = 0);
<a name="l00195"></a>00195 std::string get_file_name_no_ext(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; delim = <span class="stringliteral">&quot;.&quot;</span>, <span class="keyword">const</span> <span class="keywordtype">int</span> nLayers = 0);
<a name="l00197"></a>00197 std::string get_file_dir(<span class="keyword">const</span> std::string&amp; s);
<a name="l00199"></a>00199 std::string strip_extension(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; delim = <span class="stringliteral">&quot;.&quot;</span>);
<a name="l00201"></a>00201 std::string get_extension(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; delim = <span class="stringliteral">&quot;.&quot;</span>, <span class="keyword">const</span> <span class="keywordtype">int</span> nLayers = 0);
<a name="l00203"></a>00203 std::string remove_string(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; removeString = <span class="stringliteral">&quot; &quot;</span>);
<a name="l00205"></a>00205 std::string remove_string_all(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; removeChar = <span class="stringliteral">&quot;&apos;&quot;</span>);
<a name="l00207"></a>00207 std::string replace_string(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; from = <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> std::string&amp; to = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00209"></a>00209 std::string replace_string_all(<span class="keyword">const</span> std::string&amp; s, <span class="keyword">const</span> std::string&amp; from = <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> std::string&amp; to = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00211"></a>00211 std::string hours_minutes(<span class="keywordtype">double</span> decimalHours);
<a name="l00213"></a>00213 std::string enum_suffix(<span class="keywordtype">int</span> times);
<a name="l00215"></a>00215 std::vector&lt;std::string&gt; get_argv(<span class="keyword">const</span> std::string&amp; cmd);
<a name="l00218"></a>00218 std::vector&lt;std::string&gt; split(<span class="keyword">const</span> std::string&amp; s, <span class="keywordtype">char</span> delim);
<a name="l00219"></a>00219 
<a name="l00221"></a>00221 <span class="keywordtype">double</span> positive(<span class="keywordtype">double</span> v);
<a name="l00223"></a>00223 <span class="keywordtype">double</span> double_from_string(<span class="keyword">const</span> std::string&amp; s);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div></div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1"/><address style="text-align: right;"><small>Generated on 29 May 2020 for HexPlot by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
